#include <stddef.h>

#ifdef _MSC_VER
typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int uint32_t;
typedef unsigned long long uint64_t;
typedef signed char int8_t;
typedef signed short int16_t;
typedef signed int int32_t;
typedef signed long long int64_t;
#else
#include <stdint.h>
#endif

void __stdcall set8087cw(uint16_t);
uint16_t __stdcall get8087cw(void);
void __stdcall storet0(long double *);
void __stdcall storet1(long double *);
void __stdcall storetd(long double *, double const *);
void __stdcall storedt(double *, long double const *);
void __stdcall storetpi(long double *);
int __stdcall comparet(long double const *, long double const *);
void __stdcall chst(long double *, long double const *);
void __stdcall abst(long double *, long double const *);
void __stdcall addt(long double *, long double const *, long double const *);
void __stdcall subt(long double *, long double const *, long double const *);
void __stdcall mult(long double *, long double const *, long double const *);
void __stdcall divt(long double *, long double const *, long double const *);

#ifdef _MSC_VER
typedef struct x87extended {
	char x[12] ;
} x87extended ;
#else
typedef long double x87extended;
typedef int __CHECK_COMPILER_SUPPORTS_EXTENDED__[(sizeof(long double) == 12) * 2 - 1];
#endif

x87extended * __stdcall x87extended_alloc(double x);
x87extended * __stdcall x87extended_alloc_pi(void);
x87extended * __stdcall x87extended_alloc_read(char *s);
void __stdcall x87extended_free(x87extended *x);
double __stdcall x87extended_to_double(x87extended *x);
size_t __stdcall x87extended_show(char *s, x87extended *x);
int __stdcall x87extended_compare(x87extended *x, x87extended *y);
x87extended * __stdcall x87extended_alloc_neg(x87extended *x);
x87extended * __stdcall x87extended_alloc_abs(x87extended *x);
x87extended * __stdcall x87extended_alloc_add(x87extended *x, x87extended *y);
x87extended * __stdcall x87extended_alloc_sub(x87extended *x, x87extended *y);
x87extended * __stdcall x87extended_alloc_mul(x87extended *x, x87extended *y);
x87extended * __stdcall x87extended_alloc_div(x87extended *x, x87extended *y);
x87extended * __stdcall x87extended_alloc_peek(x87extended *a, ptrdiff_t i);
void __stdcall x87extended_poke(x87extended *a, ptrdiff_t i, x87extended *x);
int __stdcall x87extended_vorzeichen(x87extended *x);
int __stdcall x87extended_exponent(x87extended *x);
unsigned long long __stdcall x87extended_mantisse(x87extended *x);

