#include <stdio.h>
#include "..\x87extended_ffi.h"

void check(int c)
{
	if(c) printf("OK!\n"); else printf("BAD!");
}

int main()
{
	long double x, y, z;
	double d;
	check(get8087cw() == 0x037f); /* gcc's default */
	check((set8087cw(0x1372), get8087cw() == 0x1372));
	check((storet0(&x), x == 0.0));
	check((storet1(&x), x == 1.0));
	check((x = 2.0, y = 1.0, comparet(&x, &y) > 0));
	check((x = 2.0, y = 3.0, comparet(&x, &y) < 0));
	check((x = 5.0, y = 5.0, comparet(&x, &y) == 0));
	check((x = 5.0, storedt(&d, &x), d == 5.0));
	check((d = 7.0, storetd(&x, &d), x == 7.0));
	check((x = 2.0, y = 3.0, addt(&z, &x, &y), z == 5.0));

	return 0;
}
